'Placed in the Public Domain 5/24/97  John E. Carter
'johnecarter@mindspring.com
'
'requires PowerBasic 2.1 or higher to compile
'
'@(#)jcom.bas - 1.7 - 01/24/91
'basic communications program with ASCII file transfer, and printer toggle
'1/24/91  (1.7) - "Carrier Lost" in reverse video, minor change in errhandler
'11/14/90 (1.6) - made infoline reverse video, minor format changes in line
'11/3/90  (1.5) - added Alt-F(iles), minor corrections
'6/4/90   (1.4) - added command reference line at bottom off screen
'5/4/90   (1.3) - fixed cursor handling in escproc()
'5/1/90   (1.2) - changed commands to Alt-x instead of Ctrl-x
'4/29/90  (1.1) - added response to vt100 HOME and CLEAR
'3/13/90  (1.0) - added 8 character tabs and usable defaults
'
'future additions: check command line for file name to load (xxxx.jcf)
'                  display list of xxxx.jcf files and prompt for name
'
$LIB GRAPH OFF
$COMPILE EXE
defint a-z			'integers for speed
$COM 8192                       'big buffer to prevent overflow
width "lpt1:", 255
ver$="1.4"
ptr = 0
color 7,0                       'works on color or mono screen
on error goto errorhandler
cls
if command$ = "r" then
  port$="2"
  speed$="2400"
  bits$="8"
  parity$="none"
  num$="5293002"
  goto makecall
end if
print
print string$(38,32);"JCOM"
print
print "John E. Carter  johnecarter@mindspring.com"
print
print "Works with Hayes compatible modems only."
print
print "Default are COM1:, 2400 Baud, 7 Bits, Even Parity, Full Duplex"
print
print "Press RETURN at each prompt to get the default (*)"
print
input "com port (1*/2/3/4) ";port$
if port$="" then port$="1"
spd:
input "speed (300/1200/2400*/9600) ";speed$
if val(speed$) > 0 and val(speed$) < 110 then
  beep
  print "Invalid speed"
  delay 1
  goto spd
end if
if speed$="" then speed$="2400"
input "bits (7*,8) ";bits$
if bits$="" then bits$="7"
input "parity (none,even*,odd,mark,space) ";parity$
if parity$="" then parity$="even"
if bits$ = "8" then parity$="none"
line input "Number to dial: ";num$          'get the number
if num$ = "" then end
makecall:
dostr$="COM"+right$(port$,1)+":"+speed$+","+left$(parity$,1)+","+bits$+",1,cd"
print
print "    Alt-E = Exit     Alt-P = Printer on/off     Alt-D = Duplex (half/full)"
print
print "    Alt-R = Receive text       Alt-T = Transmit file    Alt-F = List files"
print "           ASCII text files only, no protocol, no error checking."
print
print "Calling ";num$;" at ";speed$;" baud"
open dostr$ as #1 LEN=8192
print #1, "ATZ"                             'reset modem
delay 3                                     'wait while it's reset
print #1, "AT&C1"
delay 1
print #1, "ATV0X1"
delay 1
print #1,"ATDT";num$                        'send dial string
delay 3                                     'wait a bit
echo = 0                                    'echo off
call infoline
while (1)                                   'loop forever
  while not instat                          'if no key pressed
    if loc(1) > 0 then                      'if characters in the buffer
      mystuff$ = input$(loc(1),#1)            'get them
      for iloc = 1 to len(mystuff$)              'process one at a time
	m$ = mid$(mystuff$,iloc,1)
	if ascii(m$) > 127 then m$ = chr$(ascii(m$) - 128)
	select case m$
	  case chr$(27)                     'Escape
	    call escproc(mystuff$,iloc)                    'go process it
	  case chr$(5)                      '^E (enq)
	    m$=""                           'don't want to print it
	    print #1,"none"                 'needed on atlsup
	  case chr$(10)                     '^J (line feed)
	    m$ = ""                         'ignore it also
	  case chr$(8)                      '^H (backspace)
	    cpos = pos(0)                   'find where we are
	    clin = csrlin
	    if cpos = 1 then incr cpos      'if at beginning, can't back up
	    locate csrlin, cpos -1          'backup one
	    print "  ";                     'clear character and cursor
	    locate csrlin, cpos -1          'backup again
	    m$ = ""                         'don't want to print it
	  case chr$(9)                      '^I (tab)
	    cpos = pos(0)
	    nextpos = (cpos - (cpos mod 8) + 8)
	    locate csrlin,nextpos
	  case chr$(7)                      '^G (bell)
	    sound 800,1                     'beep to taste
	    m$ = ""                         'don't print it
	  case chr$(13)                     '^M (return)
	    print " ";                       'clear cursor (could be a problem if end of line)
	    if csrlin < 24 then
	      locate csrlin +1 ,1
	    else
	      print
	    end if
	    if ptr then lprint
	  case else                         'for anything else
	    print m$;                       'show it
	    if ptr then lprint m$;
	end select
	csrpos = pos(0)                     'find where we are
	color 23,0                          'turn on blink
	print "_";                          'put the cursor there
	color 7,0                           'normal print
	locate csrlin, csrpos               'backup to cursor
      next iloc
      if already then print #3, mystuff$;    'if in a download, print to file
    end if
  wend
  while instat
    myinput$ = inkey$
    if len(myinput$) = 2 then
      myinput$ = right$(myinput$,1)
      if myinput$ = chr$(20) then gosub readdiskfile     'Alt-T (transmit)
      if myinput$ = chr$(19) then gosub writediskfile    'Alt-R (receive)
      if myinput$ = chr$(18) then                        'Alt-E (exit)
	locate csrlin, pos(0)
	print " "
	close
	print
	print "Terminated"
	locate 25,1
	print space$(79);
	end
      end if
      if myinput$ = chr$(25) then                   'Alt-P (printer toggle)
	ptr = abs(ptr - 1)
	myinput$ = ""
	csrpos = pos(0)
	clin = csrlin
	locate 25,76
	if (ptr) then
	  color 0,7
	else
	  color 0,0
	end if
	print "PRT";
	color 7,0
	locate clin, csrpos
      end if
      if myinput$ = chr$(32) then                    'Alt-D (duplex toggle)
	echo = abs(echo -1)                          'change state
      end if
      if myinput$ = chr$(33) then files              'Alt-F (list files)
      if myinput$ = chr$(35) then                    'Alt-H (hangup)
	delay 1
	print #1, "+++";
	delay 3
	print #1, "ATH"
      end if
    else
      print #1, myinput$;                                'send what was typed
      if echo then                                       'if echo on
	if myinput$ = chr$(9) then                       'if ^I (tab)
	  cpos = pos(0)                                  'get position
	  nextpos = cpos - (cpos mod 8) + 8              'compute next tab
	  locate csrlin,nextpos                          'go there
	  color 23,0                                     'blink on
	  print "_";                                     'put cursor
	  color 7,0                                      'blink off
	  locate csrlin, nextpos                         'backup
	else
	  print myinput$;                                  'display locally
	  csrpos = pos(0)                                  'find where we are
	  color 23,0                                       'blink on
	  print "_";                                       'put cursor
	  color 7,0                                        'blink off
	  locate csrlin, csrpos                            'backup to cursor
	end if
      end if
    end if
  wend
wend

readdiskfile:                             'Alt-T transmit a file of text
  myinput$ = ""                           'throw away Alt-T
  f$ = ""                                 'initialize file name
  cpos = pos(0)                           'find where we are
  clin = csrlin
  locate 25,1                             'go to bottom line
  print space$(79);
  locate 25,1
  color 0,7                               'reverse video
  print "File to transmit: ";             'put prompt
  inf$ = ""                               'initialize the string
  minpos = pos(0)                         'get current position (backspace stop)
  while inf$ <> chr$(13)                  'while it's not a return
    inf$ = inkey$                         'get a key
    if inf$ = chr$(8) then                'if it's a backspace
      if len(f$) > 0 then f$ = left$(f$,len(f$) -1)   'throw away last char
      if pos(0) > minpos then                         'if position is OK
	locate csrlin, pos(0) -1                      'backup one
	print " ";                                    'blank it out
	locate csrlin, pos(0) -1                      'backup
      end if
      inf$ = ""                                       'throw away this char
    end if
    if inf$ <> "" and inf$ <> chr$(13) then
      print inf$;                            'display this char
      f$ = f$ + inf$                         'add to file name
    end if
  wend
  color 7,0                                  'back to normal color
  if f$ = "" then                            'if null name
    locate 25,1                              'start of prompt
    print space$(69);                        'clear line
    locate clin,cpos                         'back to original screen location
    call infoline
    return                                   'back to keyboard send/receive
  end if
  locate clin, cpos                          'back to original screen location
100 open f$ for input as 2
  close 2
  open "r",2,f$,1024                         'open the file
  field #2, 1024 as disk$                    'define big blocks
  r& = lof(2)                                'get file size in bytes
  rec = r& \ 1024                            'get number of "records"
  for i = 1 to rec
    get 2,i                                  'read a record
    print #1, disk$;                         'send it out
  next i
  if r& mod 1024 <> 0 then                   'if not at end of file
    get +2, rec + 1                          'get last record
    print #1, left$(disk$,r& mod 1024);      'send out whatever bytes it has
  end if
  close 2                                    'close file
  cpos = pos(0)                              'find where we are
  clin = csrlin
101 locate 25,1                                'back to prompt line
  print space$(69);                          'clear it
  locate clin, cpos                          'back to original location
  call infoline
  return                                     'go back to keyboard send/receive

writediskfile:                               'Alt-R receive a file of text
  f$ = ""                                    'clear filename
  myinput$ = ""                              'throw away Alt-R
  if already then                            'file already open
    already = 0                              'clear flag
    close 3                                  'close file
    cpos = pos(0)                            'find where we are
    clin = csrlin
    locate 25,1
    print space$(79);                        'clear prompt line
    locate clin, cpos                        'back to original position
    call infoline
    return
  end if
  already = 1                    'we have a receive file open
  cpos = pos(0)                  'find where we are
  clin = csrlin
  locate 25,1                    'go to prompt line
  print space$(69);
  locate 25,1
  color 0,7                      'reverse video
  print "File to receive: ";     'give prompt
  inf$ = ""                      'clear variable
  minpos = pos(0)                'mark position to not backspace over it
  while inf$ <> chr$(13)         'collect characters up to a return
    inf$ = inkey$
    if inf$ = chr$(8) then                          'backspace handler
      if len(f$) > 0 then f$ = left$(f$,len(f$) -1)
      if pos(0) > minpos then
	locate csrlin, pos(0) -1
	print " ";
	locate csrlin, pos(0) -1
      end if
      inf$ = ""
    end if
    if inf$ <> "" and inf$ <> chr$(13) then          'display typed chars
      print inf$;
      f$ = f$ + inf$                                 'build string
    end if
  wend
  color 7,0                                          'normal video
  if f$ = "" then                                    'if null name
    already = 0                      'we don't have a file open
    locate 25,1
    print space$(69);                'clear prompt line
    locate clin,cpos                 'go back where we were
    call infoline
    return
  end if
  locate clin,cpos                   'back to starting screen position
200 open f$ for append as #3           'add to file if it exists
  return

SUB escproc(mystuff$,iloc)
escdone = 0
reused = 0
clin = csrlin
cpos = pos(0)
locate clin, cpos
print " ";
locate clin, cpos
if len(mystuff$) <> 0 then
  estuff$ = mid$(mystuff$,iloc+1, len(mystuff$) - iloc)
  mystuff$ = estuff$
  iloc = 1
  incr reused
  goto doproc
end if
while not instat
  mystuff$ = input$(loc(1),#1)                   'get chars
  reused = 0
doproc:
  for qq = 1 to len(mystuff$)
    m$ = mid$(mystuff$,qq,1)
    if ascii(m$) > 127 then m$ = chr$(ascii(m$) - 128)
    mid$(mystuff$,qq,1) = m$
  next qq
  for stuffloc = 1 to len(mystuff$)              'process one at a time
    m$ = mid$(mystuff$, stuffloc, 1)
    char$ = char$ + m$
    select case m$
      case chr$(27)
	escdone = 0
	if (reused) then incr iloc
      case "["
	incr bracket
	if (reused) then incr iloc
      case "2"
	incr two
	if (reused) then incr iloc
      case "J"
	incr jay
	if (reused) then incr iloc
      case "H"
	incr aich
	if (reused) then incr iloc
    end select
    if reused and (jay or aich) then decr iloc
    if (bracket and two and jay) then
      clin = csrlin
      cpos = pos(0)
      cls
      locate 25,1
      print "Alt-D(uplex)  Alt-E(xit)  Alt-P(rinter)  Alt-R(ecv)  Alt-T(rans)  Alt-F(iles)";
      locate clin,cpos
      bracket = 0
      two = 0
      jay = 0
      if instr(mystuff$, chr$(27)) = 0 then
	incr escdone
      end if
    end if
    if (bracket and aich) then
      escdone = 0
      clin = csrlin
      cpos = pos(0)
      if cpos > 1 then
	locate clin,cpos -1
      else
	locate clin,cpos
      end if
      print " ";
      locate 1,1
      bracket = 0
      aich = 0
      if instr(mystuff$, chr$(27)) = 0 then
	incr escdone
      end if
    end if
  next stuffloc
  if (escdone) then exit sub
wend
END SUB 'escproc

SUB endstuff(mystuff$,stuffloc)
    for k = stuffloc+1 to len(mystuff$)
      t$ = mid$(mystuff$,k,1)
      print t$;
    next k
    cpos = pos(0)
    color 23,0
    print "_";
    color 7,0
    locate csrlin, cpos
END SUB 'endstuff

SUB infoline
  clin = csrlin
  cpos = pos(0)
  locate 25,1
  color 0,7
  print "Alt-D(uplex)  Alt-E(xit)  Alt-P(rinter)  Alt-R(cv)  Alt-T(rn)  Alt-F(iles)";
  color 7,0
  locate clin,cpos
END SUB 'infoline

errorhandler:
  if err = 57 and erl = 0 then locate 25,1:color 0,7:print "Carrier Lost";:color 7,0:end
  if err = 53 or err = 54 or err = 55 or err = 57 or err = 64 or err = 67_
   or err = 75 or err = 76 then
    tmperr = erl
    if tmperr = 100 or tmperr = 200 then
      locate 25,1
      color 7,0
      print space$(69);
      color 0,2
      locate 25,1
      print "can't open ";f$;
      beep
      delay 1
      locate 25,1
      color 7,0
      print space$(69);
      f$ = ""
      if tmperr = 100 then resume 101
      if tmperr = 200 then already = 0:resume next
    end if
    locate 25,1
    color 7,0
    print space$(69);
    locate 25,1
    print "Unrecoverable error ";err;" at ";erl;
    end
  end if
  print "err";err,"erl";erl
